Index: trunk/LMDZ.MARS/libf/phymars/physiq_mod.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/physiq_mod.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/physiq_mod.F	(revision 1974)
@@ -17,7 +17,8 @@
       use co2cloud_mod, only: co2cloud, mem_Mccn_co2, mem_Mh2o_co2,
      &                        mem_Nccn_co2
-      use aeropacity_mod
-      use callradite_mod
-      use callsedim_mod
+      use callradite_mod, only: callradite
+      use callsedim_mod, only: callsedim
+      use rocketduststorm_mod, only: rocketduststorm, dustliftday
+      use calcstormfract_mod, only: calcstormfract
       use tracer_mod, only: noms, mmol, igcm_co2, igcm_n2, igcm_co2_ice,
      &                      igcm_co, igcm_o, igcm_h2o_vap, igcm_h2o_ice,
@@ -27,8 +28,10 @@
      &                      igcm_dust_mass, igcm_dust_number, igcm_h2o2,
      &                      nuice_ref, rho_ice, rho_dust, ref_r0,
-     &                      igcm_he
+     &                      igcm_he, igcm_stormdust_mass,
+     &                      igcm_stormdust_number 
       use comsoil_h, only: inertiedat, ! soil thermal inertia
      &                     tsoil, nsoilmx ! number of subsurface layers
-      use geometry_mod, only: longitude, latitude, cell_area
+      use geometry_mod, only: longitude, latitude, cell_area,
+     &                        longitude_deg 
       use comgeomfi_h, only: sinlon, coslon, sinlat, coslat
       use surfdat_h, only: phisfi, albedodat, zmea, zstd, zsig, zgam,
@@ -36,6 +39,7 @@
      &                     frost_albedo_threshold,
      &                     tsurf, co2ice, emis,
-     &                     capcal, fluxgrd, qsurf
-      use comsaison_h, only: dist_sol, declin, mu0, fract
+     &                     capcal, fluxgrd, qsurf,
+     &                     hmons
+      use comsaison_h, only: dist_sol, declin, mu0, fract, local_time
       use slope_mod, only: theta_sl, psi_sl
       use conc_mod, only: rnew, cpnew, mmean
@@ -48,5 +52,5 @@
       use planete_h, only: aphelie, periheli, year_day, peri_day,
      &                     obliquit
-      USE comcstfi_h, only: r, cpp, mugaz, g, rcp, pi, rad
+      USE comcstfi_h, only: r, cpp, mugaz, g, rcp, pi, rad 
       USE calldrag_noro_mod, ONLY: calldrag_noro
       USE vdifc_mod, ONLY: vdifc
@@ -54,4 +58,5 @@
      &                      fill_data_thermos, allocate_param_thermos
       use iono_h, only: allocate_param_iono
+      use compute_dtau_mod, only: compute_dtau
 #ifdef MESOSCALE
       use comsoil_h, only: mlayer,layer
@@ -64,4 +69,5 @@
       use eofdump_mod, only: eofdump
       USE vertical_layers_mod, ONLY: ap,bp,aps,bps
+     
 #endif
 
@@ -207,4 +213,5 @@
       REAL,INTENT(out) :: pdpsrf(ngrid) ! surface pressure tendency (Pa/s)
 
+      
 
 c Local saved variables:
@@ -212,7 +219,9 @@
       INTEGER,SAVE :: day_ini ! Initial date of the run (sol since Ls=0)
       INTEGER,SAVE :: icount     ! counter of calls to physiq during the run.
+
 #ifdef DUSTSTORM
       REAL pq_tmp(ngrid, nlayer, 2) ! To compute tendencies due the dust bomb
 #endif
+            
 c     Variables used by the water ice microphysical scheme:
       REAL rice(ngrid,nlayer)    ! Water ice geometric mean radius (m)
@@ -257,8 +266,14 @@
       REAL fluxtop_sw(ngrid,2)     !Outgoing SW (solar) flux to space (W.m-2)
       REAL tauref(ngrid)           ! Reference column optical depth at odpref
+c     rocket dust storm
+      REAL totstormfract(ngrid)     ! fraction of the mesh where the dust storm is contained
+      logical clearatm              ! clearatm used to calculate twice the radiative 
+                                    ! transfer when rdstorm is active : 
+                                    !            - in a mesh with stormdust and background dust (false)
+                                    !            - in a mesh with background dust only (true)
+      
       real,parameter :: odpref=610. ! DOD reference pressure (Pa)
       REAL tau(ngrid,naerkind)     ! Column dust optical depth at each point
                                    ! AS: TBD: this one should be in a module !
-      REAL dsodust(ngrid,nlayer)   ! density-scaled opacity (in infrared) 
       REAL zls                       !  solar longitude (rad)
       REAL zday                      ! date (time since Ls=0, in martian days)
@@ -271,6 +286,6 @@
       REAL zdtlw(ngrid,nlayer)     ! (K/s)
       REAL zdtsw(ngrid,nlayer)     ! (K/s)
-!      REAL cldtlw(ngrid,nlayer)     ! (K/s) LW heating rate for clear area
-!      REAL cldtsw(ngrid,nlayer)     ! (K/s) SW heating rate for clear area
+      REAL pdqrds(ngrid,nlayer,nq) ! tendency for dust after rocketduststorm
+
       REAL zdtnirco2(ngrid,nlayer) ! (K/s)
       REAL zdtnlte(ngrid,nlayer)   ! (K/s)
@@ -315,4 +330,9 @@
       PARAMETER (length=100)
 
+c     Variables for the total dust for diagnostics
+      REAL qdusttotal(ngrid,nlayer) !it equals to dust + stormdust
+
+      INTEGER iaer
+
 c local variables only used for diagnostic (output in file "diagfi" or "stats")
 c -----------------------------------------------------------------------------
@@ -320,4 +340,5 @@
       REAL zu(ngrid,nlayer),zv(ngrid,nlayer)
       REAL zq(ngrid,nlayer,nq)
+
       REAL fluxtop_sw_tot(ngrid), fluxsurf_sw_tot(ngrid)
       character*2 str2
@@ -325,4 +346,5 @@
       real zdtdif(ngrid,nlayer), zdtadj(ngrid,nlayer)
       real rdust(ngrid,nlayer) ! dust geometric mean radius (m)
+      real rstormdust(ngrid,nlayer) ! stormdust geometric mean radius (m)
       integer igmin, lmin
       logical tdiag
@@ -340,4 +362,6 @@
       real mass(nq)             ! global mass of tracers (g)
       REAL mtot(ngrid)          ! Total mass of water vapor (kg/m2)
+      REAL mstormdtot(ngrid)    ! Total mass of stormdust tracer (kg/m2)
+      REAL mdusttot(ngrid)    ! Total mass of dust tracer (kg/m2)
       REAL icetot(ngrid)        ! Total mass of water ice (kg/m2)
       REAL mtotco2(ngrid)       ! Total mass of co2 vapor (kg/m2)
@@ -360,4 +384,13 @@
       REAL nccn(ngrid,nlayer)  ! true n ccn (kg/kg)
       REAL qccn(ngrid,nlayer)  ! true q ccn (kg/kg)
+c     definition tendancies of stormdust tracers
+      REAL rdsdqdustsurf(ngrid) ! surface q stormdust flux (kg/m2/s)
+      REAL rdsdndustsurf(ngrid) ! surface n stormdust flux (number/m2/s)
+      REAL rdsndust(ngrid,nlayer) ! true n stormdust (kg/kg)
+      REAL rdsqdust(ngrid,nlayer) ! true q stormdust (kg/kg)
+      REAL wspeed(ngrid,nlayer+1) ! vertical speed tracer stormdust
+      REAL dsodust(ngrid,nlayer) 
+      REAL dsords(ngrid,nlayer)
+
       REAL nccnco2(ngrid,nlayer)   ! true n ccnco2 (kg/kg)
       REAL qccnco2(ngrid,nlayer)  ! true q ccnco2 (kg/kg)
@@ -396,5 +429,7 @@
       REAL tstar(ngrid)  ! friction velocity and friction potential temp
       REAL L_mo(ngrid),vhf(ngrid),vvv(ngrid)
-!      REAL zu2(ngrid)
+      real qdustrds0(ngrid,nlayer),qdustrds1(ngrid,nlayer)
+      real qstormrds0(ngrid,nlayer),qstormrds1(ngrid,nlayer)   
+      real qdusttotal0(ngrid),qdusttotal1(ngrid)
 
 c sub-grid scale water ice clouds (A. Pottier 2013)
@@ -543,5 +578,6 @@
      &                 nsoilmx,ngrid,nlayer,nq,
      &                 ptimestep,pday,time_phys,cell_area,
-     &                 albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe)
+     &                 albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe,
+     &                 hmons)
          endif
 #endif
@@ -565,4 +601,5 @@
       zdtsurf(:)=0
       dqsurf(:,:)=0
+      
 #ifdef DUSTSTORM
       pq_tmp(:,:,:)=0
@@ -572,5 +609,9 @@
 
       zday=pday+ptime ! compute time, in sols (and fraction thereof)
-    
+      ! Compute local time at each grid point
+      DO ig=1,ngrid
+       local_time(ig)=modulo(1.+(zday-INT(zday))
+     &                +(longitude_deg(ig)/15)/24,1.)
+      ENDDO
 c     Compute Solar Longitude (Ls) :
 c     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -702,11 +743,17 @@
      &                             zdtnlte(1:ngrid,1:nlayer)/86400.
               endif
-           else
+           ELSE
               zdtnlte(:,:)=0.
-           endif
+           ENDIF !end callnlte
 
 c          Find number of layers for LTE radiation calculations
            IF(MOD(iphysiq*(icount-1),day_step).EQ.0)
      &          CALL nlthermeq(ngrid,nlayer,zplev,zplay)
+
+c          rocketstorm : compute dust storm mesh fraction
+           IF (rdstorm) THEN
+              CALL calcstormfract(ngrid,nlayer,nq,pq,
+     &                 totstormfract)
+           ENDIF
 
 c          Note: Dustopacity.F has been transferred to callradite.F
@@ -724,5 +771,6 @@
 c          Transfer through CO2 (except NIR CO2 absorption)
 c            and aerosols (dust and water ice)
-
+           ! callradite for background dust
+           clearatm=.true.
 c          Radiative transfer
 c          ------------------
@@ -730,8 +778,11 @@
            clearsky=.false. ! part with clouds for both cases CLFvarying true/false 
            CALL callradite(icount,ngrid,nlayer,nq,zday,zls,pq,albedo,
-     $     emis,mu0,zplev,zplay,pt,tsurf,fract,dist_sol,igout,
-     $     zdtlw,zdtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,fluxtop_sw,
-     $     tauref,tau,aerosol,dsodust,tauscaling,taucloudtes,rdust,rice,
-     $     nuice,co2ice,clearsky,totcloudfrac)
+     &     emis,mu0,zplev,zplay,pt,tsurf,fract,dist_sol,igout,
+     &     zdtlw,zdtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,
+     &     fluxtop_sw,tauref,tau,aerosol,dsodust,tauscaling,
+     &     taucloudtes,rdust,rice,nuice,co2ice,rstormdust,
+     &     totstormfract,clearatm,dsords,
+     &     clearsky,totcloudfrac)
+
            ! case of sub-grid water ice clouds: callradite for the clear case
             IF (CLFvarying) THEN
@@ -746,5 +797,6 @@
      &              fluxsurf_swclf,fluxtop_lwclf,fluxtop_swclf,tauref,
      &              tau,aerosol,dsodust,tauscaling,taucloudtesclf,rdust,
-     &              rice,nuice,co2ice, clearsky, totcloudfrac)
+     &              rice,nuice,co2ice,rstormdust,totstormfract,
+     &              clearatm,dsords,clearsky,totcloudfrac)
                clearsky = .false.  ! just in case.
                ! Sum the fluxes and heating rates from cloudy/clear
@@ -774,10 +826,18 @@
 
             ENDIF ! (CLFvarying)
-
+            
+           ! Dustinjection
+           if (dustinjection.gt.0) then
+             CALL compute_dtau(ngrid,nlayer,
+     &        			zday,pplev,tauref,
+     &        			ptimestep,dustliftday,local_time)
+           endif
+c============================================================================
+           
 #ifdef DUSTSTORM
 !! specific case: compute the added quantity of dust for perturbation
        if (firstcall) then
          pdq(1:ngrid,1:nlayer,igcm_dust_mass)= 
-     &      pdq(1:ngrid,1:nlayer,igcm_dust_mass)
+     &      pdq(1:ngrid,1:nlayer,igcm_dust_mass)     
      &      - pq_tmp(1:ngrid,1:nlayer,1)
      &      + pq(1:ngrid,1:nlayer,igcm_dust_mass)
@@ -897,6 +957,86 @@
       ENDIF ! of IF (callrad)
 
+c     3. Rocket dust storm
+c    -------------------------------------------
+      IF (rdstorm) THEN
+         clearatm=.false.
+         pdqrds(:,:,:)=0.
+         qdusttotal0(:)=0.
+         qdusttotal1(:)=0.
+         do ig=1,ngrid
+           do l=1,nlayer
+            zdh(ig,l)=pdt(ig,l)/zpopsk(ig,l) ! updated potential
+                                             ! temperature tendency
+            ! for diagnostics
+            qdustrds0(ig,l)=pq(ig,l,igcm_dust_mass)+
+     &           pdq(ig,l,igcm_dust_mass)*ptimestep
+            qstormrds0(ig,l)=pq(ig,l,igcm_stormdust_mass)+
+     &           pdq(ig,l,igcm_stormdust_mass)*ptimestep
+            qdusttotal0(ig)=qdusttotal0(ig)+(qdustrds0(ig,l)+
+     &          qstormrds0(ig,l))*(zplev(ig,l)-
+     &           zplev(ig,l+1))/g
+           enddo
+         enddo
+         call writediagfi(ngrid,'qdustrds0','qdust before rds',
+     &           'kg/kg ',3,qdustrds0)
+         call writediagfi(ngrid,'qstormrds0','qstorm before rds',
+     &           'kg/kg ',3,qstormrds0)
+
+         CALL rocketduststorm(ngrid,nlayer,nq,ptime,ptimestep,
+     &                      pq,pdq,pt,pdt,zplev,zplay,zzlev,
+     &                      zzlay,zdtsw,zdtlw,
+c               for radiative transfer
+     &                      clearatm,icount,zday,zls,
+     &                      tsurf,igout,totstormfract,
+c               input sub-grid scale cloud
+     &                      clearsky,totcloudfrac,
+c               output
+     &                      pdqrds,wspeed,dsodust,dsords)
+                   
+c      update the tendencies of both dust after vertical transport
+         DO l=1,nlayer
+          DO ig=1,ngrid
+           pdq(ig,l,igcm_stormdust_mass)=
+     &              pdq(ig,l,igcm_stormdust_mass)+ 
+     &                      pdqrds(ig,l,igcm_stormdust_mass)
+           pdq(ig,l,igcm_stormdust_number)=
+     &              pdq(ig,l,igcm_stormdust_number)+
+     &                      pdqrds(ig,l,igcm_stormdust_number)
+
+           pdq(ig,l,igcm_dust_mass)=
+     &       pdq(ig,l,igcm_dust_mass)+ pdqrds(ig,l,igcm_dust_mass)
+           pdq(ig,l,igcm_dust_number)=
+     &           pdq(ig,l,igcm_dust_number)+ 
+     &                  pdqrds(ig,l,igcm_dust_number)
+
+          ENDDO
+         ENDDO
+         do l=1,nlayer
+           do ig=1,ngrid
+             qdustrds1(ig,l)=pq(ig,l,igcm_dust_mass)+
+     &           pdq(ig,l,igcm_dust_mass)*ptimestep
+             qstormrds1(ig,l)=pq(ig,l,igcm_stormdust_mass)+
+     &           pdq(ig,l,igcm_stormdust_mass)*ptimestep
+             qdusttotal1(ig)=qdusttotal1(ig)+(qdustrds1(ig,l)+
+     &          qstormrds1(ig,l))*(zplev(ig,l)-
+     &           zplev(ig,l+1))/g
+           enddo
+         enddo
+
+c        for diagnostics
+         call writediagfi(ngrid,'qdustrds1','qdust after rds',
+     &           'kg/kg ',3,qdustrds1)
+         call writediagfi(ngrid,'qstormrds1','qstorm after rds',
+     &           'kg/kg ',3,qstormrds1)
+         
+         call writediagfi(ngrid,'qdusttotal0','q sum before rds',
+     &           'kg/kg ',2,qdusttotal0)
+         call writediagfi(ngrid,'qdusttotal1','q sum after rds',
+     &           'kg/kg ',2,qdusttotal1)
+
+      ENDIF ! end of if(rdstorm)
+
 c-----------------------------------------------------------------------
-c    3. Gravity wave and subgrid scale topography drag :
+c    4. Gravity wave and subgrid scale topography drag :
 c    -------------------------------------------------
 
@@ -917,5 +1057,5 @@
 
 c-----------------------------------------------------------------------
-c    4. Vertical diffusion (turbulent mixing):
+c    5. Vertical diffusion (turbulent mixing):
 c    -----------------------------------------
 
@@ -968,6 +1108,6 @@
      $        zdum1,zdum2,zdh,pdq,zflubid,
      $        zdudif,zdvdif,zdhdif,zdtsdif,q2,
-     &        zdqdif,zdqsdif,wstar,zcdv,zcdh,hfmax_th,sensibFlux)
-
+     &        zdqdif,zdqsdif,wstar,zcdv,zcdh,hfmax_th,sensibFlux,
+     &	      dustliftday,local_time)
 
           DO ig=1,ngrid
@@ -1018,8 +1158,8 @@
              zdqdif(1:ngrid,2:nlayer,1:nq) = 0.
              DO iq=1, nq
-              IF ((iq .ne. igcm_dust_mass)
-     &        .and. (iq .ne. igcm_dust_number)) THEN
-                zdqsdif(:,iq)=0.
-              ENDIF
+               IF ((iq .ne. igcm_dust_mass)
+     &          .and. (iq .ne. igcm_dust_number)) THEN
+                 zdqsdif(:,iq)=0.
+               ENDIF
              ENDDO
            ELSE
@@ -1041,5 +1181,5 @@
 
 c-----------------------------------------------------------------------
-c   5. Thermals :
+c   6. Thermals :
 c   -----------------------------
 
@@ -1085,7 +1225,6 @@
         lmax_th_out(:)=0.
       end if
-
 c-----------------------------------------------------------------------
-c   5. Dry convective adjustment:
+c   7. Dry convective adjustment:
 c   -----------------------------
 
@@ -1107,5 +1246,4 @@
      $                zduadj,zdvadj,zdhadj,
      $                zdqadj)
-
 
          DO l=1,nlayer
@@ -1133,10 +1271,10 @@
 
 c-----------------------------------------------------------------------
-c   6. Specific parameterizations for tracers 
+c   8. Specific parameterizations for tracers 
 c:   -----------------------------------------
 
       if (tracer) then 
 
-c   6a. Water and ice
+c   8a. Water and ice
 c     ---------------
 
@@ -1219,5 +1357,5 @@
          END IF  ! of IF (water)
 
-c   6a bis. CO2 clouds (CL & JA)
+c   8a bis. CO2 clouds (CL & JA)
 c        ---------------------------------------
 c        CO2 ice cloud condensation in the atmosphere
@@ -1342,7 +1480,6 @@
 
 
-c   6b. Aerosol particles
+c   8b. Aerosol particles
 c     -------------------
-
 c        ----------
 c        Dust devil :
@@ -1371,5 +1508,5 @@
 c        ------------- 
 c        Sedimentation :   acts also on water ice
-c        ------------- 
+c        -------------
          IF (sedimentation) THEN 
            zdqsed(1:ngrid,1:nlayer,1:nq)=0
@@ -1378,8 +1515,8 @@
 c Sedimentation for co2 clouds tracers are inside co2cloud microtimestep
 c Zdqssed isn't
-           call callsedim(ngrid,nlayer, ptimestep,
-     &                zplev,zzlev, zzlay, pt, pdt, rdust, rice,
-     &                rsedcloud,rhocloud,
-     &                pq, pdq, zdqsed, zdqssed,nq, 
+           call callsedim(ngrid,nlayer,ptimestep,
+     &                zplev,zzlev,zzlay,pt,pdt,rdust,rstormdust,
+     &                rice,rsedcloud,rhocloud,
+     &                pq,pdq,zdqsed,zdqssed,nq, 
      &                tau,tauscaling)
 c Flux at the surface of co2 ice computed in co2cloud microtimestep
@@ -1387,4 +1524,20 @@
               zdqssed(1:ngrid,igcm_co2_ice)=zdqssed_co2(1:ngrid)
            ENDIF
+
+           IF (rdstorm) THEN
+c             Storm dust cannot sediment to the surface
+              DO ig=1,ngrid  
+                 zdqsed(ig,1,igcm_stormdust_mass)=
+     &             zdqsed(ig,1,igcm_stormdust_mass)+
+     &             zdqssed(ig,igcm_stormdust_mass) /
+     &             ((pplev(ig,1)-pplev(ig,2))/g)
+                 zdqsed(ig,1,igcm_stormdust_number)=
+     &             zdqsed(ig,1,igcm_stormdust_number)+
+     &             zdqssed(ig,igcm_stormdust_number) /
+     &               ((pplev(ig,1)-pplev(ig,2))/g) 
+                 zdqssed(ig,igcm_stormdust_mass)=0.
+                 zdqssed(ig,igcm_stormdust_number)=0.
+              ENDDO
+           ENDIF !rdstorm
 
            DO iq=1, nq
@@ -1400,6 +1553,7 @@
              ENDDO
            ENDDO
+
          END IF   ! of IF (sedimentation)
-        
+
 c Add lifted dust to tendancies after sedimentation in the LES (AC)
       IF (turb_resolved) THEN
@@ -1417,7 +1571,6 @@
            ENDDO
       ENDIF
-
 c
-c   6c. Chemical species
+c   8c. Chemical species
 c     ------------------
 
@@ -1493,5 +1646,5 @@
 #endif
 
-c   6d. Updates
+c   8d. Updates
 c     ---------
 
@@ -1511,5 +1664,5 @@
 #ifndef MESOSCALE
 c-----------------------------------------------------------------------
-c   7. THERMOSPHERE CALCULATION
+c   9. THERMOSPHERE CALCULATION
 c-----------------------------------------------------------------------
 
@@ -1535,7 +1688,6 @@
       endif ! of if (callthermos)
 #endif
-
 c-----------------------------------------------------------------------
-c   8. Carbon dioxide condensation-sublimation:
+c   10. Carbon dioxide condensation-sublimation:
 c     (should be the last atmospherical physical process to be computed)
 c   -------------------------------------------
@@ -1607,13 +1759,11 @@
 #endif
       
-      ENDIF  ! of IF (callcond)
-      
-
+      ENDIF  ! of IF (callcond)      
 c-----------------------------------------------------------------------
-c   9. Surface  and sub-surface soil temperature
+c   11. Surface  and sub-surface soil temperature
 c-----------------------------------------------------------------------
 c
 c
-c   9.1 Increment Surface temperature:
+c   11.1 Increment Surface temperature:
 c   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
@@ -1656,5 +1806,5 @@
 
 c
-c   9.2 Compute soil temperatures and subsurface heat flux:
+c   11.2 Compute soil temperatures and subsurface heat flux:
 c   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       IF (callsoil) THEN
@@ -1669,8 +1819,40 @@
         ENDIF
       ENDIF
-      
+
+c     To avoid negative values
+      IF (rdstorm) THEN
+           where (pq(:,:,igcm_stormdust_mass) + 
+     &      ptimestep*pdq(:,:,igcm_stormdust_mass) < 0.)
+             pdq(:,:,igcm_stormdust_mass) = 
+     &       - pq(:,:,igcm_stormdust_mass)/ptimestep + 1.e-30
+             pdq(:,:,igcm_stormdust_number) = 
+     &       - pq(:,:,igcm_stormdust_number)/ptimestep + 1.e-30
+           end where
+           where (pq(:,:,igcm_stormdust_number) + 
+     &      ptimestep*pdq(:,:,igcm_stormdust_number) < 0.)
+             pdq(:,:,igcm_stormdust_mass) = 
+     &       - pq(:,:,igcm_stormdust_mass)/ptimestep + 1.e-30
+             pdq(:,:,igcm_stormdust_number) = 
+     &       - pq(:,:,igcm_dust_number)/ptimestep + 1.e-30
+           end where
+
+            where (pq(:,:,igcm_dust_mass) + 
+     &      ptimestep*pdq(:,:,igcm_dust_mass) < 0.)
+             pdq(:,:,igcm_dust_mass) = 
+     &       - pq(:,:,igcm_dust_mass)/ptimestep + 1.e-30
+             pdq(:,:,igcm_dust_number) = 
+     &       - pq(:,:,igcm_dust_number)/ptimestep + 1.e-30
+           end where
+           where (pq(:,:,igcm_dust_number) + 
+     &      ptimestep*pdq(:,:,igcm_dust_number) < 0.)
+             pdq(:,:,igcm_dust_mass) = 
+     &       - pq(:,:,igcm_dust_mass)/ptimestep + 1.e-30
+             pdq(:,:,igcm_dust_number) = 
+     &       - pq(:,:,igcm_dust_number)/ptimestep + 1.e-30
+           end where
+      ENDIF !(rdstorm)   
 
 c-----------------------------------------------------------------------
-c  10. Write output files
+c  12. Write output files
 c  ----------------------
 
@@ -1885,4 +2067,30 @@
               endif
            endif ! of (doubleq)
+
+           if (rdstorm) then   ! diagnostics of stormdust tendancies for 1D and 3D
+              mstormdtot(:)=0
+              mdusttot(:)=0
+              qdusttotal(:,:)=0
+              do ig=1,ngrid 
+                rdsdqdustsurf(ig) = 
+     &                zdqssed(ig,igcm_stormdust_mass)*tauscaling(ig)
+                rdsdndustsurf(ig) = 
+     &                zdqssed(ig,igcm_stormdust_number)*tauscaling(ig)
+                rdsndust(ig,:) =
+     &                pq(ig,:,igcm_stormdust_number)*tauscaling(ig)
+                rdsqdust(ig,:) =
+     &                pq(ig,:,igcm_stormdust_mass)*tauscaling(ig)
+                do l=1,nlayer
+                    mstormdtot(ig) = mstormdtot(ig) + 
+     &                      zq(ig,l,igcm_stormdust_mass) * 
+     &                      (zplev(ig,l) - zplev(ig,l+1)) / g
+                    mdusttot(ig) = mdusttot(ig) + 
+     &                      zq(ig,l,igcm_dust_mass) * 
+     &                      (zplev(ig,l) - zplev(ig,l+1)) / g
+                    qdusttotal(ig,l) = qdust(ig,l)+rdsqdust(ig,l) !calculate total dust
+                enddo
+              enddo
+           endif !(rdstorm)
+
            if (co2clouds) then
               do ig=1,ngrid 
@@ -1906,6 +2114,5 @@
               enddo
            endif ! of if (co2clouds)
-           
-                    
+                              
            if (water) then
              mtot(:)=0
@@ -2138,4 +2345,12 @@
                call wstats(ngrid,'dustN','Dust number',
      &                        'part/kg',3,ndust)
+               if (rdstorm) then
+                 call wstats(ngrid,'reffstormdust','reffdust',
+     &                          'm',3,rstormdust*ref_r0)
+                 call wstats(ngrid,'rdsdustq','Dust mass mr',
+     &                          'kg/kg',3,rdsqdust)
+                 call wstats(ngrid,'rdsdustN','Dust number',
+     &                        'part/kg',3,rdsndust)
+               end if
              else
                do iq=1,dustbin
@@ -2345,5 +2560,5 @@
 c        call WRITEDIAGFI(ngrid,'lw_htrt','lw heat. rate',
 c    &                   'w.m-2',3,zdtlw)
-  
+ 
             if (.not.activice) then
                CALL WRITEDIAGFI(ngrid,'tauTESap',
@@ -2434,5 +2649,4 @@
      &                       qsurf(1:ngrid,igcm_h2o_ice))
 #endif
-
             CALL WRITEDIAGFI(ngrid,'mtot',
      &                       'total mass of water vapor',
@@ -2443,9 +2657,9 @@
             vmr=zq(1:ngrid,1:nlayer,igcm_h2o_ice)
      &      *mmean(1:ngrid,1:nlayer)/mmol(igcm_h2o_ice)
-            call WRITEDIAGFI(ngrid,'vmr_h2oice','h2o ice vmr',
+            CALL WRITEDIAGFI(ngrid,'vmr_h2oice','h2o ice vmr',
      &                       'mol/mol',3,vmr)
             vmr=zq(1:ngrid,1:nlayer,igcm_h2o_vap)
      &      *mmean(1:ngrid,1:nlayer)/mmol(igcm_h2o_vap)
-            call WRITEDIAGFI(ngrid,'vmr_h2ovap','h2o vap vmr',
+            CALL WRITEDIAGFI(ngrid,'vmr_h2ovap','h2o vap vmr',
      &                       'mol/mol',3,vmr)
             CALL WRITEDIAGFI(ngrid,'reffice',
@@ -2555,8 +2769,9 @@
      &                        'part/kg',3,ndust)
              call WRITEDIAGFI(ngrid,'dsodust',
-     &                        'dust density scaled opacity',
-     &                        'm2.kg-1',3,dsodust)
-c             call WRITEDIAGFI(ngrid,"tauscaling",
-c     &                    "dust conversion factor"," ",2,tauscaling)
+     &                       'density scaled optcial depth',
+     &                       'm2.kg-1',3,dsodust)
+             call WRITEDIAGFI(ngrid,'dso',
+     &                       'density scaled optcial depth',
+     &                       'm2.kg-1',3,dsodust+dsords)
            else
              do iq=1,dustbin
@@ -2569,4 +2784,55 @@
            endif ! (doubleq)
 
+           if (rdstorm) then  ! writediagfi tendencies stormdust tracers
+             call WRITEDIAGFI(ngrid,'reffdust','reffdust',
+     &                        'm',3,rdust*ref_r0)
+             call WRITEDIAGFI(ngrid,'reffstormdust','reffstormdust',
+     &                        'm',3,rstormdust*ref_r0)
+             call WRITEDIAGFI(ngrid,'mstormdtot',
+     &                        'total mass of stormdust only',
+     &                        'kg.m-2',2,mstormdtot)
+             call WRITEDIAGFI(ngrid,'mdusttot',
+     &                        'total mass of dust only',
+     &                        'kg.m-2',2,mdusttot)
+             call WRITEDIAGFI(ngrid,'rdsdqsdust',
+     &                        'deposited surface stormdust mass',
+     &                        'kg.m-2.s-1',2,rdsdqdustsurf)
+             call WRITEDIAGFI(ngrid,'rdsdustq','storm Dust mass mr',
+     &                        'kg/kg',3,rdsqdust)
+             call WRITEDIAGFI(ngrid,'rdsdustqmodel','storm Dust massmr',
+     &                        'kg/kg',3,pq(:,:,igcm_stormdust_mass))
+             call WRITEDIAGFI(ngrid,'rdsdustN','storm Dust number',
+     &                        'part/kg',3,rdsndust)
+             call WRITEDIAGFI(ngrid,"stormfract",
+     &                "fraction of the mesh, with stormdust","none",
+     &                                               2,totstormfract)
+             call WRITEDIAGFI(ngrid,'qsurf',
+     &                 'stormdust injection',
+     &                 'kg.m-2',2,qsurf(:,igcm_stormdust_mass))
+             call WRITEDIAGFI(ngrid,'pdqsurf',
+     &                  'tendancy stormdust mass at surface',
+     &                  'kg.m-2',2,dqsurf(:,igcm_stormdust_mass))
+             call WRITEDIAGFI(ngrid,'wspeed','vertical speed stormdust',
+     &                        'm/s',3,wspeed(:,1:nlayer))
+             call WRITEDIAGFI(ngrid,'zdqsed_dustq'
+     &          ,'sedimentation q','kg.m-2.s-1',3,
+     &          zdqsed(:,:,igcm_dust_mass))
+             call WRITEDIAGFI(ngrid,'zdqssed_dustq'
+     &          ,'sedimentation q','kg.m-2.s-1',2,
+     &          zdqssed(:,igcm_dust_mass))
+             call WRITEDIAGFI(ngrid,'zdqsed_rdsq'
+     &          ,'sedimentation q','kg.m-2.s-1',3,
+     &          zdqsed(:,:,igcm_stormdust_mass))
+             call WRITEDIAGFI(ngrid,'rdust','rdust',
+     &                        'm',3,rdust)
+             call WRITEDIAGFI(ngrid,'rstormdust','rstormdust',
+     &                        'm',3,rstormdust)
+             call WRITEDIAGFI(ngrid,'totaldustq','total dust mass',
+     &                        'kg/kg',3,qdusttotal)
+             call WRITEDIAGFI(ngrid,'dsords',
+     &                       'density scaled opacity of stormdust',
+     &                       'm2.kg-1',3,dsords)
+           endif ! (rdstorm)
+
            if (scavenging) then
              call WRITEDIAGFI(ngrid,'ccnq','CCN mass mr',
@@ -2574,4 +2840,8 @@
              call WRITEDIAGFI(ngrid,'ccnN','CCN number',
      &                        'part/kg',3,nccn)
+             call WRITEDIAGFI(ngrid,'surfccnq','Surf nuclei mass mr',
+     &                        'kg.m-2',2,qsurf(1,igcm_ccn_mass))
+             call WRITEDIAGFI(ngrid,'surfccnN','Surf nuclei number',
+     &                        'kg.m-2',2,qsurf(1,igcm_ccn_number))
            endif ! (scavenging)
 
